Код репозитория основан на [ironpython-stubs](https://github.com/gtalarico/ironpython-stubs).
Выражаю [gtalarico](https://github.com/gtalarico) бесконечную благодарность за вклад в развитие сообщества разработчиков скриптов и плагинов для инженерных программ.
Я не стал делать форк его репозитория потому что хочу внести координальные изменения,
к тому же автор уже давно им не занимается, а приемник так и не был найден.

Так же как и в базовом репозитории, "заглушки" могут быть использованы в различных текстовых рекдаторах, но все примеры будут рассматриваться в [visual studio code](https://code.visualstudio.com/).

На самом деле сгенерированный код нельзя называть "заглушками", но данное название уже прижилось в сообществе. Если хотите узнать про настоящие заглушки для python кода, то почитайте [тут](https://mypy.readthedocs.io/en/stable/stubs.html).

## Для пользователей
Сгенерированные заглушки ищите в [релизах](https://github.com/BIMOpenGroup/revitapistubs/releases).
Как вы можете заметить, они разделены на `common` и `revit`.  
В `common` храняться заглушки системных библиотек Windows, пакеты IronPython, [Dynamo](https://github.com/DynamoDS) и [RPS](https://github.com/architecture-building-systems/revitpythonshell).  
В `revit` храняться заглушки для нескольких версий библиотек `Revit API`.  
Чтобы не было конфликтов у анализатора кода, подключать заглушки надо с помощью двух путей.

```json
// global settings.json
"python.analysis.extraPaths": [
    "ВАШ_ПУТЬ\\stubs\\common",
    "ВАШ_ПУТЬ\\stubs\\revit\\2019"
],
```

Изменяя версию Revit для конкретного проекта, придётся повторить оба пути.

```json
// .vscode/settings.json
"python.analysis.extraPaths": [
    "ВАШ_ПУТЬ\\stubs\\common",
    "ВАШ_ПУТЬ\\stubs\\revit\\2021"
],
```

Подробнее о подключении доп модулей читайте [тут](https://code.visualstudio.com/docs/python/editing).  
Примеры использования заглушек смотрите [тут](https://github.com/BIMOpenGroup/revitapistubs/examples).  
Для максимальной эффектиности заглушек их надо допиливать руками, но об этом подробней в примерах.  
Надеюсь в будущем это будет исправлено.

Если выйдет новая версия Revit API, но при этом код генерации не измениться, то будет обновлён архив последнего релиза.  

## Для котрибьюторов
Любая помощь приветствуется!  
Пишите вопросы, предложения, замечания. Даже если я не смогу что-то поправить вовремя, то возможно кто-то из сообщества поможет.

### Общая информация
Генерация заглушек возможна через консоль и это выглядит предпочтительным и гибким вариантом, но для простоты я выбрал [RevitPythonShell](https://github.com/architecture-building-systems/revitpythonshell).
Например не надо заботиться о дополнительных зависимостях для `RevitAPIUI` или требовать пути для генерации,
просто открываем нужный нам Revit и запускаем скрипт.
К тому же данный репозиторий создан для генерации заглушек только для Revit.

Из-за того что `Pylance` достаточно производительный в отличии от `Jedi` заглушки больше не нужно "минимизировать".
Поэтому раньше требовалось запускать скрипт для обработки сгенерированных заглушек и формирования `stubs.min`.

Решил разместить заглушки в релизах потому что нет смысла хранить их в репозитории.
Единственная причина хранения их в репозитории если кто-то будет их обновлять/исправлять руками, но это очень большой и не нужный труд. Лучше попробовать улучшить генератор.

### Как генерировать заглушки
В оболочке RPS запускаем `src/main.py` изменив при этом путь к `src_dir`.   
Если запускать через кастомную кнопку на панели RPS, то в коде ничего менять не надо.  
Заглушки сгенерируются в корне репозитория.

### Правила
Как и практически в любом опенсорсе тут принята система [Forking Workflow](https://www.atlassian.com/git/tutorials/comparing-workflows/forking-workflow).  
Тезисно:
- Делаем форк репозитория;
- Создаём ветку от `master`;
- Делаем `pull request` в `upstream/master`.

Правила именования веток:
- Стиль cebab-case;
- Первым словом идёт задача fix/feature/refactor и т.д. Последующими краткое описание либо номер issue.
    fix-iss57 / feature-iss14 / refactor-generator.

Просьба добавить папки различных IDE в свой глобальный gitignore.

### Текущие задачи
На данный момент приоритетной задачей является улучшение кода генератора.